searchNodes=[{"doc":"RedMutex defines an easy to use interface to control an distributed lock backed by redis.UsageWhen used, the mutex expects the :otp_app as option. The :otp_app should point to an OTP application that has the mutex configuration. For example, the mutex:defmodule MyApp.MyMutex do use RedMutex, otp_app: :my_app endCould be configured with:config :my_app, MyApp.MyMutex, url: &quot;redis://localhost:6379&quot;, key: &quot;red_mutex_lock&quot;, expiration_in_seconds: 3_600Options::url - the redis url. Required.:key- The key at redis used to store the lock information. Defaults to &quot;red_mutex_lock&quot;.:expiration_in_seconds - Time in seconds that the resource will be kept locked. After that time the lock will be automattically released. Defaults to 3600, one hour.Example# In your config/config.exs file config :my_app, MyApp.MyMutex, url: &quot;redis://localhost:6379&quot;, key: &quot;red_mutex_lock&quot;, expiration_in_seconds: 3_600 # In your application code defmodule MyApp.MyMutex do use RedMutex, otp_app: :my_app end defmodule MyApp do import RedMutex, only: [synchronize: 1] alias MyApp.MyMutex def syncronized_work do synchronize({__MODULE__, :work, []}) end def lock_unlock do case MyMutex.acquire_lock() do {:ok, lock} -&gt; work() MyMutex.release_lock(lock) {:error, reason} -&gt; {:error, reason} end end def work do # do some work {:ok, &quot;completed&quot;} end end","ref":"RedMutex.html","title":"RedMutex","type":"behaviour"},{"doc":"Attempts to acquire an lock.Examplesiex&gt; MyMutex.acquire_lock() {:ok, lock} iex&gt; MyMutex.acquire_lock() {:error, :already_locked} iex&gt; MyMutex.acquire_lock() {:error, reason}","ref":"RedMutex.html#c:acquire_lock/0","title":"RedMutex.acquire_lock/0","type":"callback"},{"doc":"Checks if an lock exists. Returns {:ok, true} if the resource is locked.Examplesiex&gt; MyMutex.exists_lock() {:ok, true} iex&gt; MyMutex.exists_lock() {:ok, false} iex&gt; MyMutex.exists_lock() {:error, reason}","ref":"RedMutex.html#c:exists_lock/0","title":"RedMutex.exists_lock/0","type":"callback"},{"doc":"Releases the lock.Examplesiex&gt; MyMutex.release_lock(lock) :ok iex&gt; MyMutex.release_lock(lock) {:error, :unlock_fail} iex&gt; MyMutex.release_lock(lock) {:error, reason}","ref":"RedMutex.html#c:release_lock/1","title":"RedMutex.release_lock/1","type":"callback"},{"doc":"Obtains an lock, run the callback, and releases the lock when the block completes.Examplesiex&gt; MyMutex.synchronize(fn -&gt; ...&gt; # work ...&gt; {:ok, &quot;completed&quot;} ...&gt; end) {:ok, &quot;completed&quot;} iex&gt; MyMutex.synchronize({MyApp, :work, []}) {:ok, &quot;completed&quot;}","ref":"RedMutex.html#c:synchronize/1","title":"RedMutex.synchronize/1","type":"callback"},{"doc":"","ref":"RedMutex.html#t:callback/0","title":"RedMutex.callback/0","type":"type"},{"doc":"","ref":"RedMutex.html#t:lock/0","title":"RedMutex.lock/0","type":"type"},{"doc":"","ref":"RedMutex.html#t:reason/0","title":"RedMutex.reason/0","type":"type"}]